/* ****************************************************************************
 *
 * rayme - ray tracing application for virtual 3D scenes 
 *
 * ----------------------------------------------------------------------------
 *
 * Andrej Rypak, xrypak@gmail.com, 2011 - 2012
 *
 * Thsesis project - Raytracing of Virtual Graphics Scenes
 * Brno University of Technology, Faculty of Information Technologies
 * Andrej Rypak, xrypak00@stud.fit.vutbr.cz, 2011/2012,
 * under supervision of Jan Peciva, PhD.
 *
 ******************************************************************************/


#ifndef RAYME_EVENTHANDLER_H
#define	RAYME_EVENTHANDLER_H


#include <osgViewer/ViewerEventHandlers>
#include <osgGA/GUIEventHandler>
#include <osgGA/GUIEventAdapter>
#include <osgGA/GUIActionAdapter>

#include "common.h"
#include "RayManager.h"
#include "WindowManager.h"
#include "UILayer.h"

namespace Rayme {

	//
	/**
	 * 
	 */
	class EventHandler : public osgGA::GUIEventHandler {
	public:
		EventHandler(UILayer& ui, RayManager* rm, WindowManager *wm);
		virtual bool handle(const osgGA::GUIEventAdapter& ea, osgGA::GUIActionAdapter& aa);
		void getUsage(osg::ApplicationUsage& usage) const;
	protected:
		RayManager* _rm;
		WindowManager* _wm;
		UILayer& _ui;
		bool _written;
		uchar _select;
	};


}

#endif	/* RAYME_EVENTHANDLER_H */

