/* ****************************************************************************
 *
 * rayme - ray tracing application for virtual 3D scenes 
 *
 * ----------------------------------------------------------------------------
 *
 * Andrej Rypak, xrypak@gmail.com, 2011 - 2012
 *
 * Thsesis project - Raytracing of Virtual Graphics Scenes
 * Brno University of Technology, Faculty of Information Technologies
 * Andrej Rypak, xrypak00@stud.fit.vutbr.cz, 2011/2012,
 * under supervision of Jan Peciva, PhD.
 *
 ******************************************************************************/

#include "LightSourceVisitor.h"
#include <osg/NodeVisitor>
#include <osg/Group>

using namespace Rayme;

LightSourceVisitor::LightSourceVisitor(LightSources& lightSources) : osg::NodeVisitor(TRAVERSE_ALL_CHILDREN),
_lightSources(lightSources) {
}


void LightSourceVisitor::apply(osg::LightSource& node) {
	_lightSources.push_back(&node);
	osg::NodeVisitor::apply((osg::Group&)node);
}

