/* ****************************************************************************
 *
 * rayme - ray tracing application for virtual 3D scenes 
 *
 * ----------------------------------------------------------------------------
 *
 * Andrej Rypak, xrypak@gmail.com, 2011 - 2012
 *
 * Thsesis project - Raytracing of Virtual Graphics Scenes
 * Brno University of Technology, Faculty of Information Technologies
 * Andrej Rypak, xrypak00@stud.fit.vutbr.cz, 2011/2012,
 * under supervision of Jan Peciva, PhD.
 *
 ******************************************************************************/


#ifndef RAYME_LIGHTSOURCEVISITOR_H
#define	RAYME_LIGHTSOURCEVISITOR_H

#include "common.h"
#include <osg/LightSource>
#include <osg/NodeVisitor>

namespace Rayme {

	typedef std::vector<osg::LightSource*> LightSources;
	class WorldLightSourceContainer {
	public:
		LightSources sources;
		std::vector<osg::Vec4d> positions;
		std::vector<osg::Vec3d> directions;
	};
	class LightSourceVisitor : public osg::NodeVisitor {
	public:
		LightSourceVisitor(LightSources& lightSources);

	public:
		virtual void apply(osg::LightSource& node);

	protected:
		LightSources& _lightSources;
	};

}

#endif	/* RAYME_LIGHTSOURCEVISITOR_H */

