/* ****************************************************************************
 *
 * rayme - ray tracing application for virtual 3D scenes 
 *
 * ----------------------------------------------------------------------------
 *
 * Andrej Rypak, xrypak@gmail.com, 2011 - 2012
 *
 * Thsesis project - Raytracing of Virtual Graphics Scenes
 * Brno University of Technology, Faculty of Information Technologies
 * Andrej Rypak, xrypak00@stud.fit.vutbr.cz, 2011/2012,
 * under supervision of Jan Peciva, PhD.
 *
 ******************************************************************************/


#ifndef RAYME_PHOTOREALISMDATA_H
#define	RAYME_PHOTOREALISMDATA_H

#include <osg/Node>
#include <map>
#include <string>


namespace Rayme {
	class PhotorealismData {
	public:
		PhotorealismData();
		PhotorealismData(const osg::Node *node);
		virtual ~PhotorealismData();
		void include(const osg::Node *node);
		std::map< std::string, std::string > getData() const;
		bool contains(const std::string& key);
		std::string get(const std::string& key);

	protected:
		osg::ref_ptr<osg::Node> _node;
		std::map< std::string, std::string > _data;


	};
}
#endif	/* RAYME_PHOTOREALISMDATA_H */

