/* ****************************************************************************
 *
 * rayme - ray tracing application for virtual 3D scenes 
 *
 * ----------------------------------------------------------------------------
 *
 * Andrej Rypak, xrypak@gmail.com, 2011 - 2012
 *
 * Thsesis project - Raytracing of Virtual Graphics Scenes
 * Brno University of Technology, Faculty of Information Technologies
 * Andrej Rypak, xrypak00@stud.fit.vutbr.cz, 2011/2012,
 * under supervision of Jan Peciva, PhD.
 *
 ******************************************************************************/


#include "ReflectedRay.h"


using namespace Rayme;


ReflectedRay::ReflectedRay(osg::Vec3d start, osg::Vec3d direction, uchar currentDepth, uchar maxDepth) :
SecondaryRay(start + direction * POINT_PRECISION, start + direction * POINT_INFINITY, 1.0, currentDepth, maxDepth) {
}


ReflectedRay::ReflectedRay(osg::Vec3d start, osg::Vec3d direction, double weight, uchar currentDepth, uchar maxDepth) :
SecondaryRay(start + direction * POINT_PRECISION, start + direction * POINT_INFINITY, weight, currentDepth, maxDepth) {
}


ReflectedRay::~ReflectedRay() {
}


void ReflectedRay::selfTrace(Tracer const& tracer) {

	if (_debugInfo) {
//		std::cout << "self tracing reflected" << std::endl;
	}

	osgUtil::IntersectionVisitor intersectionVisitor(this);
	intersectionVisitor.setUseKdTreeWhenAvailable(true);
	tracer.getScene()->accept(intersectionVisitor);
	setTraced();
}

