/* ****************************************************************************
 *
 * rayme - ray tracing application for virtual 3D scenes 
 *
 * ----------------------------------------------------------------------------
 *
 * Andrej Rypak, xrypak@gmail.com, 2011 - 2012
 *
 * Thsesis project - Raytracing of Virtual Graphics Scenes
 * Brno University of Technology, Faculty of Information Technologies
 * Andrej Rypak, xrypak00@stud.fit.vutbr.cz, 2011/2012,
 * under supervision of Jan Peciva, PhD.
 *
 ******************************************************************************/


#ifndef RAYME_REFLECTEDRAY_H
#define	RAYME_REFLECTEDRAY_H

#include "common.h"
#include "SecondaryRay.h"

namespace Rayme {
	class ReflectedRay : public SecondaryRay {
	public:
		ReflectedRay(osg::Vec3d start, osg::Vec3d direction, uchar currentDepth, uchar maxDepth);
		ReflectedRay(osg::Vec3d start, osg::Vec3d direction, double weight, uchar currentDepth, uchar maxDepth);
		virtual ~ReflectedRay();

	public:
		virtual void selfTrace(Tracer const& tracer);
	};

}
#endif	/* RAYME_REFLECTEDRAY_H */

