/* ****************************************************************************
 *
 * rayme - ray tracing application for virtual 3D scenes 
 *
 * ----------------------------------------------------------------------------
 *
 * Andrej Rypak, xrypak@gmail.com, 2011 - 2012
 *
 * Thsesis project - Raytracing of Virtual Graphics Scenes
 * Brno University of Technology, Faculty of Information Technologies
 * Andrej Rypak, xrypak00@stud.fit.vutbr.cz, 2011/2012,
 * under supervision of Jan Peciva, PhD.
 *
 ******************************************************************************/


#ifndef RAYME_SHADOWRAY_H
#define	RAYME_SHADOWRAY_H

#include <osg/Node>
#include <osgUtil/LineSegmentIntersector>
#include <osg/Vec3d>
#include "common.h"
#include "RayIntersector.h"

namespace Rayme {
	class ShadowRay {
	public:
		ShadowRay(osg::Node* scene, const osgUtil::LineSegmentIntersector::Intersection& intersection, const osg::Vec3d lightPosition, bool selfShadow = true);
		virtual ~ShadowRay();

	public:
		bool castsFullShadow() const;
		double getLightContribution() const;

	protected:
		double transparencyCheck(osgUtil::LineSegmentIntersector::Intersection const& intersection) const;
		
	protected:
		bool _fullShadow;
		bool _direct;
		double _lightContribution;

	};
}
#endif	/* RAYME_SHADOWRAY_H */

