/* ****************************************************************************
 *
 * rayme - ray tracing application for virtual 3D scenes 
 *
 * ----------------------------------------------------------------------------
 *
 * Andrej Rypak, xrypak@gmail.com, 2011 - 2012
 *
 * Thsesis project - Raytracing of Virtual Graphics Scenes
 * Brno University of Technology, Faculty of Information Technologies
 * Andrej Rypak, xrypak00@stud.fit.vutbr.cz, 2011/2012,
 * under supervision of Jan Peciva, PhD.
 *
 ******************************************************************************/


#ifndef RAYME_MANIPULATORS_H
#define	RAYME_MANIPULATORS_H

#include "osgGA/FirstPersonManipulator"

#include "common.h"


namespace Rayme {
/**
 * FPS camera manipulator with vertical movement.
 */
class FPSVerticalManipulator : public osgGA::FirstPersonManipulator {
public:

protected:


};


/**
 * Manipulator used to discard any manipulation with the camera of the ray-tracing window.
 */
class DiscardManipulator : public osgGA::CameraManipulator {
public:
	/** Handles events. Returns true if handled, false otherwise.*/
	bool handle(const osgGA::GUIEventAdapter& ea, osgGA::GUIActionAdapter& aa) {
		return true;
	}


	virtual void setByMatrix(const osg::Matrixd& matrix);
	virtual void setByInverseMatrix(const osg::Matrixd& matrix);
	virtual osg::Matrixd getMatrix() const;
	virtual osg::Matrixd getInverseMatrix() const;


};


}


#endif	/* RAYME_MANIPULATORS_H */

